#include <iostream>
using namespace std;

int main()
{
    // ulaz
    int N,Q;
    cin >> N >> Q;

    int p[N];
    long long int d[N],k[Q];

    for(int i=0;i<N;i++)
    {
        cin >> d[i] >> p[i];
    } 

    for(int i=0;i<Q;i++)
    {
        cin >> k[i];
    } 




    // resavanje

   
    long long int br_pojedene_plazme=0;
 
    for(int j=0;j<Q;j++)
    {
        for(int i=0;i<N;i++)
        {
            if(d[i] + p[i] <= (k[j] + 1)) br_pojedene_plazme += p[i];
            else
            {
                if(d[i] <= k[j]) br_pojedene_plazme += k[j] - d[i] + 1;
            }
        }

        cout << br_pojedene_plazme << "\n";
        br_pojedene_plazme = 0;


    }



  








    return 0;
}